//////////////////////////////////////////////////////////////////////////
//                                                                      //
// ceil.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// ceil --
//
//    ,    
//
double ceil(double f){
	LONG m, r;
	int e, s, sc;

    //   double
	DstrDouble(f, m, e, s);

	if (e < 0){
		if(s==1 || (m==0 && e==-0x3ff))                 //     
			return ConstructDouble(0, -0x3ff, s, 0);    //  0
		else
			return 1;
	}

	if (e > 51){	        //   
		return f;
	}
	
	sc = 52 - e;
	r = m & (0x001fffffffffffff >> (e+1));
	m >>= sc;               //  
	if (!s && r)
		m++;                //       -  
	m <<= sc;

	if (m == 0x0020000000000000){	
		m = 0;
		e++;
	}

    //   double
	return ConstructDouble(m, e, s, 0);
}

#ifdef __cplusplus
}
#endif
