//////////////////////////////////////////////////////////////////////////
//                                                                      //
// ceilf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:06p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// ceilf --
//
//    ,    
//
float ceilf(float f){
	int m, e, s, sc, r;

    //   double
    DestructFloat(f, m, e, s, sc);

	if (e < 0){
		if(s==1 || (m==0 && e==-127))                //     
			return ConstructFloat(0, -127, s, 0);    //  0
		else
			return 1;
	}

	if (e > 22){	        //   
		return f;
	}
	
	sc = 23 - e;
	r = m & (0x00ffffff >> (e+1));
	m >>= sc;               //  
	if (!s && r)
		m++;                //       -  
	m <<= sc;

	if (m == 0x01000000){	
		m = 0;
		e++;
	}

    //   double
	return ConstructFloat(m, e, s, 0);
}

#ifdef __cplusplus
}
#endif
