//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           fdiv.asm                                       //
//                                                                          //
//        32  (float)        //
// FDiv -     2 float   32 .                          //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .     .

global FDiv :label;


extern FFrExp           :label;
extern FResult          :label;
extern FPIEEE_Signal    :label;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//=====  FDiv =================================
//     . 32- 
//    .
//  :     .
// +0 = SP    
// -1 = , float 32 
// -2 = , float 32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - , float 32 
// : ar5
<FDiv>
    pop ar5,gr5 with gr7 = gr5;     // ar5 - , gr5 - 
    push ar0,gr0 with gr0 = gr5;    // gr0 - 
    push ar1,gr1 with gr5 = gr7;    //  gr5
    gr1 = ar5;                      // gr1 - 
    push ar2,gr2;
    push ar3,gr3;
    push ar4,gr4
        with gr4 = gr0 xor gr1;

        //  
    push ar0, gr0;
    call FFrExp;
    push ar1, gr1
        with gr1 = gr7;

        //  
    call FFrExp;
    pop ar2, gr2        //    
        with gr1 or gr7;
    pop ar3, gr3;       //    
    if <>0 delayed skip Abnormal
        with gr2 -= gr3;
    gr3 = ar3;      //  
    gr0 = ar2;      //  
    // cond. skip Abnormal
    gr7 = 00800000h
        with gr3;
    if =0 skip DivByZero
        with gr0;
        
        //     .
        //   0,    0.
    if =0 skip Zero with gr3 - gr7;
    if u>= skip DivLoop
        with gr1 = false;
        
<AdjLoop>
    gr3 <<= 1;
    with gr3 - gr7;
    if u< skip AdjLoop
        with gr2++;
<DivLoop>
    with gr0 - gr3;
    if u< delayed skip L1
        with gr1 C<<= 1;
    with gr1 - gr7;
    gr2-- noflags;
    // cond. skip L1
    gr0 -= gr3 noflags;
<L1>
    if u< skip DivLoop
        with gr0 <<= 1;

    if <>0 delayed skip L2
        with gr3 = gr0 - gr3;
    gr7 = 127 + 24;
    // cond. skip L2
    gr3 = false;
<L2>
    delayed call FResult
        with gr0 = false noflags;
    gr0 C>>= 1;
    gr2 += gr7;
    // call FResult;
<Ret>
    pop ar4, gr4;
    pop ar3, gr3;
    pop ar2, gr2;
    pop ar1, gr1;
    pop ar0, gr0;
    return;

<Zero>
    skip Ret with gr7 = false;
    
<DivByZero>
    with gr0;
    if =0 skip Invalid;     // 0/0
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_DivByZero;
    // call FPIEEE_Signal;
    gr7 = 7f800000h;
    delayed skip Ret
        with gr4 >>= 31;
    gr4 <<= 31;
    gr7 = gr7 or gr4;
    // skip Ret;

<Abnormal>
    with gr1;
    if < skip NaN1;
    if > skip Inf1
        with gr7;
    if < skip NaN2;
<Inf2>
    gr7 = 7f800000h;
    delayed skip Ret
        with gr4 >>= 31;
    gr4 <<= 31;
    gr7 = gr7 or gr4;
    // skip Ret;
<Inf1>
    if <= skip Inf2;
    skip Invalid;  // Inf/Inf
<NaN1>
    with gr1 + 1;
    if <>0 skip Invalid;    // signaling NaN
<NaN2>
    with gr7 + 1;
    gr7 = true noflags;
    if >= skip Ret;

<Invalid>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    skip Ret
        with gr7 = true;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         fdiv.asm                               //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
