//////////////////////////////////////////////////////////////////////////
//                                                                      //
// ldexp.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:08p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

// frexpff --
//
//     2   
//
double ldexp(double f, int ip){
	LONG m;
	int	e, s;

    //   double
    DstrDouble(f, m, e, s);
	if (e == 0x400)		    //  NAN, inf
		return ConstructDouble(0x1fffffffffffff, 0x400, s, 0);
	if (m){
		if (e == -0x3ff){
            //  
			while ( !(m & 0x10000000000000)){
				m<<=1;
				e--;
			}
			e++;
		}
	}
	else if (e == -0x3ff)   //  0
		return f;

	if (e+ip>0x3ff){        //  
		if (!_FPIEEE_Flags)
			_FPIEEE_Signal( _FPIEEE_Overflow );
		return ConstructDouble(0, 0x400, s, 0);
	}
	if (e+ip>-0x3ff)        //   
		return ConstructDouble(m, e+ip, s, 0);

	if (e+ip>-0x44f){       //  
		while ( e+ip!=-0x3ff){
			m>>=1;
			ip++;
		}
		int Adder = m & 1;
		m>>=1;
        //   double
		return ConstructDouble(m+Adder, e+ip, s, 0);
	}
    //   double
	return ConstructDouble(0, -0x3ff, s, 0);
}

#ifdef __cplusplus
}
#endif
