//----------------------------------------------------------------
//
// Copyright (c) 1996-1998 RC Module Inc.
// NeuroChip NM6403.
//
// int.cpp
//    .
// ver 1.0.
//
// by Alexey A. Chelubeev
//
//----------------------------------------------------------------

#include "nc_int.h"

extern "C" {

extern InterruptFunc InterruptVectors[10];

//----------------------------------------------------------------------//
//                                                                      //
// SetInterrupt -                                                       //
//        .                            //
//                                                                      //
// :                                                           //
//           num.    //
//           0,    .   //
//                                                                      //
//  :                                                    //
//         num   function.      //
//                                                                      //
//----------------------------------------------------------------------//

InterruptFunc SetInterrupt ( 
        InterruptNum num,       //  .
	    InterruptFunc function  //   .
    )
{
    InterruptFunc OldVector = InterruptVectors[ num - 1 ];
    InterruptVectors[ num - 1 ] = function;
    return OldVector;
}

//----------------------------------------------------------------------//
//                                                                      //
// GetInterrupt -                                                       //
//        .                               //
//                                                                      //
// :                                                           //
//             num.        //
//           0,    .   //
//                                                                      //
//  :                                                    //
//         num   function.      //
//                                                                      //
//----------------------------------------------------------------------//

InterruptFunc GetInterrupt ( 
        InterruptNum num        //  .
    )
{
    return InterruptVectors[ num - 1 ];
}

//----------------------------------------------------------------------//
//                                                                      //
// ClearInterrupt -                                                     //
//        .                               //
//                                                                      //
// :                                                           //
//             num.        //
//           0,    .   //
//                                                                      //
//  :                                                    //
//         num  .             .      //
//                                                                      //
//----------------------------------------------------------------------//

InterruptFunc ClearInterrupt ( 
        InterruptNum num        //  .
    )
{
	return SetInterrupt ( num, 0 );
}

};  // extern "C"
