#ifndef	_MALLOC_INTERNAL
#define _MALLOC_INTERNAL
#include <malloc.h>
#endif
#include <assert.h>
#include <string.h>

const int oneLShift[] = { 1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024 };

_heap_control_block     _hcb0 =
{
        0,                        /* __malloc_initialized */
        __default_morecore0,      /*      (*__morecore)   */
        NULL,                     /* *_malloc_heapbase;   */
        NULL,                     /* _heapinfo            */
        0,                        /* _heapindex;          */
        0,                        /* _heaplimit;          */
        /* Instrumentation.  */
        0,                        /* _chunks_used;        */
        0,                        /* _bytes_used;         */
        0,                        /* _chunks_free;        */
        0                         /* _bytes_free;         */
/*        struct list               _fraghead[BLOCKLOG];  */
/*        unsigned int        heapsize;     */
};

_heap_control_block     _hcb1 =
{
        0,                        /* __malloc_initialized */
        __default_morecore1,      /*      (*__morecore)   */
        NULL,                     /* *_malloc_heapbase;   */
        NULL,                     /* _heapinfo            */
        0,                        /* _heapindex;          */
        0,                        /* _heaplimit;          */
        /* Instrumentation.  */
        0,                        /* _chunks_used;        */
        0,                        /* _bytes_used;         */
        0,                        /* _chunks_free;        */
        0                         /* _bytes_free;         */
/*        struct list               _fraghead[BLOCKLOG];  */
/*        unsigned int        heapsize;     */
};

_heap_control_block     _hcb2 =
{
        0,                        /* __malloc_initialized */
        __default_morecore2,      /*      (*__morecore)   */
        NULL,                     /* *_malloc_heapbase;   */
        NULL,                     /* _heapinfo            */
        0,                        /* _heapindex;          */
        0,                        /* _heaplimit;          */
        /* Instrumentation.  */
        0,                        /* _chunks_used;        */
        0,                        /* _bytes_used;         */
        0,                        /* _chunks_free;        */
        0                         /* _bytes_free;         */
/*        struct list               _fraghead[BLOCKLOG];  */
/*        unsigned int        heapsize;     */
};

_heap_control_block     _hcb3 =
{
        0,                        /* __malloc_initialized */
        __default_morecore3,      /*      (*__morecore)   */
        NULL,                     /* *_malloc_heapbase;   */
        NULL,                     /* _heapinfo            */
        0,                        /* _heapindex;          */
        0,                        /* _heaplimit;          */
        /* Instrumentation.  */
        0,                        /* _chunks_used;        */
        0,                        /* _bytes_used;         */
        0,                        /* _chunks_free;        */
        0                         /* _bytes_free;         */
/*        struct list               _fraghead[BLOCKLOG];  */
/*        unsigned int        heapsize;     */
};

/* Aligned allocation.  */
static __ptr_t align (__malloc_size_t size,_heap_control_block *cb)
{
  __ptr_t result;
  unsigned int adj;

  result = cb->__morecore(size);

  //assert (!result || ( (cb==&_hcb1) ? __IN_HEAP1(result): 
		//				(cb==&_hcb2) ? __IN_HEAP2(result):
		//				(cb==&_hcb3) ? __IN_HEAP3(result):
		//				(cb==&_hcb4) && __IN_HEAP4(result) ) );

  adj = (unsigned int) ((unsigned int) ((char *) result -
						  (char *) NULL)) % BLOCKSIZE;
  if (adj != 0)
    {
      adj = BLOCKSIZE - adj;
      if (cb->__morecore(adj)==NULL)
       {
           cb->__morecore(-size);
           return NULL;
       };
      result = (char *) result + adj;
    }
  assert (!result || ( (cb==&_hcb0) ? __IN_HEAP0(result): 
						(cb==&_hcb1) ? __IN_HEAP1(result):
						(cb==&_hcb2) ? __IN_HEAP2(result):
						(cb==&_hcb3) && __IN_HEAP3(result) ) );
  return result;
}

/* Set everything up and remember that we have.  */
static int initialize (_heap_control_block *cb)
{
	int cbHs = HEAP / BLOCKSIZE;
  cb->heapsize = cbHs;
	malloc_info* cbHi = (malloc_info *) align (cbHs * sizeof (malloc_info),cb);
  cb->_heapinfo = cbHi;
  if (cbHi == NULL)
    return 0;
  memset (cbHi, 0, cbHs * sizeof (malloc_info));
  
  StructFree& mi = cb->_heapinfo[0].free;
  
  mi.size = 0;
  mi.next = mi.prev = 0;
  cb->_heapindex = 0;
  cb->_malloc_heapbase = (char *) cbHi;

  /* Account for the _heapinfo block itself in the statistics.  */
  cb->_bytes_used = cbHs * sizeof (malloc_info);
  cb->_chunks_used = 1;

  cb->__malloc_initialized = 1;
  return 1;
}

/* Get neatly aligned memory, initializing or
   growing the heap info table as necessary. */
static __ptr_t morecore __P ((__malloc_size_t,_heap_control_block *));
__ptr_t morecore (__malloc_size_t size,_heap_control_block *cb )
{
  __ptr_t result;
  malloc_info *newinfo, *oldinfo;
  __malloc_size_t newsize;

  result = align (size,cb);
  if (result == NULL)
    return NULL;

  /* Check if we need to grow the info table.  */
  if ((__malloc_size_t) BLOCK ((char *) result + size,cb) > cb->heapsize)
    {
      newsize = cb->heapsize;
      while ((__malloc_size_t) BLOCK ((char *) result + size,cb) > newsize)
	newsize *= 2;
      newinfo = (malloc_info *) align (newsize * sizeof (malloc_info),cb);
      if (newinfo == NULL)
	{
	  cb->__morecore(-size);
	  return NULL;
	}
      memcpy (newinfo, cb->_heapinfo, cb->heapsize * sizeof (malloc_info));
      memset (&newinfo[cb->heapsize], 0,
	      (newsize - cb->heapsize) * sizeof (malloc_info));
      oldinfo = cb->_heapinfo;
      newinfo[BLOCK (oldinfo,cb)].busy.type = 0;
      newinfo[BLOCK (oldinfo,cb)].busy.info.size
	= BLOCKIFY (cb->heapsize * sizeof (malloc_info));
      cb->_heapinfo = newinfo;
      /* Account for the _heapinfo block itself in the statistics.  */
        /* small cheating to keep statistics good */
         cb->_bytes_used -=cb->heapsize*sizeof(malloc_info);
         cb->_bytes_used +=BLOCKIFY (cb->heapsize * sizeof (malloc_info))*BLOCKSIZE;
      cb->_bytes_used += newsize * sizeof (malloc_info);
      ++cb->_chunks_used;
      __free_internal (oldinfo,cb);
      cb->heapsize = newsize;
    }

  cb->_heaplimit = BLOCK ((char *) result + size,cb);
  assert (!result || ( (cb==&_hcb0) ? __IN_HEAP0(result): 
						(cb==&_hcb1) ? __IN_HEAP1(result):
						(cb==&_hcb2) ? __IN_HEAP2(result):
						(cb==&_hcb3) && __IN_HEAP3(result) ) );
  return result;
}

/* Allocate memory from the heap.  */

__ptr_t __malloc_internal __P ((__malloc_size_t,_heap_control_block*));

__ptr_t __malloc_internal (__malloc_size_t size,_heap_control_block *cb)
{
  __ptr_t result;
  __malloc_size_t block, blocks, lastblocks, start;
  register __malloc_size_t i;
  struct list *next;

  /* ANSI C allows `malloc (0)' to either return NULL, or to return a
     valid address you can realloc and free (though not dereference).

     It turns out that some extant code (sunrpc, at least Ultrix's version)
     expects `malloc (0)' to return non-NULL and breaks otherwise.
     Be compatible.  */

#if	0
  if (size == 0)
    return NULL;
#endif

  if (!cb->__malloc_initialized)
    if (!initialize (cb))
      return NULL;

  if (size < sizeof (struct list))
      size = sizeof (struct list);

#ifdef SUNOS_LOCALTIME_BUG
  if (size < 16)
    size = 16;
#endif
  if (size < 66 && size >= 32)
    size = 66;

	/* Determine the allocation policy based on the request size.  */
	if (size <= BLOCKSIZE / 2)
	{
		/* Small allocation to receive a fragment of a block.
		Determine the logarithm to base two of the fragment size. */
		register __malloc_size_t log = 1;
		--size;
		while ((size /= 2) != 0)
			++log;
		int roundedSize = oneLShift[log];

		/* Look in the fragment lists for a
		free fragment of the desired size. */
		next = cb->_fraghead[log].next;
		if (next != NULL)
		{
		/* There are free fragments of this size.
			Pop a fragment out of the fragment list and return it.
			Update the block's nfree and first counters. */
		result = (__ptr_t) next;
		next->prev->next = next->next;
		if (next->next != NULL)
			next->next->prev = next->prev;
		block = BLOCK (result,cb);
		if (--cb->_heapinfo[block].busy.info.frag.nfree != 0)
			cb->_heapinfo[block].busy.info.frag.first = (unsigned int)
			((unsigned int) ((char *) next->next - (char *) NULL)
			% BLOCKSIZE) >> log;

		/* Update the statistics.  */
		++cb->_chunks_used;
		cb->_bytes_used += roundedSize;
		--cb->_chunks_free;
		cb->_bytes_free -= roundedSize;
		}
		else
		{
		/* No free fragments of the desired size, so get a new block
			and break it into fragments, returning the first.  */
		result = __malloc_internal (BLOCKSIZE,cb);
          assert (!result || ( (cb==&_hcb0) ? __IN_HEAP0(result): 
						        (cb==&_hcb1) ? __IN_HEAP1(result):
						        (cb==&_hcb2) ? __IN_HEAP2(result):
						        (cb==&_hcb3) && __IN_HEAP3(result) ) );
		if (result == NULL)
			return NULL;

		/* Link all fragments but the first into the free list.  */
		int lesOptShift = 0;
		__malloc_size_t lesOptfragsInBlock = (__malloc_size_t)(BLOCKSIZE >> log);
		for (i = 1; i < lesOptfragsInBlock; ++i)
			{
				lesOptShift += roundedSize;
				next = (struct list *) ((char *) result + lesOptShift);
				struct list* nn = cb->_fraghead[log].next;
				struct list* np = &(cb->_fraghead[log]);
				next->next = nn;
				next->prev = np;
				np->next = next;
				if (nn != NULL)
					nn->prev = next;
			}

		/* Initialize the nfree and first counters for this block.  */
		block = BLOCK (result,cb);
		cb->_heapinfo[block].busy.type = log;
		cb->_heapinfo[block].busy.info.frag.nfree = i - 1;
		cb->_heapinfo[block].busy.info.frag.first = i - 1;

		cb->_chunks_free += (BLOCKSIZE >> log) - 1;
		cb->_bytes_free += BLOCKSIZE - roundedSize;
		cb->_bytes_used -= BLOCKSIZE - roundedSize;
		}
    }
	else
		{
		/* Large allocation to receive one or more blocks.
		Search the free list in a circle starting at the last place visited.
		If we loop completely around without finding a large enough
		space we will have to get more memory from the system.  */
		blocks = BLOCKIFY (size);
		start = block = cb->_heapindex;
		while (cb->_heapinfo[block].free.size < blocks)
		{
			block = cb->_heapinfo[block].free.next;
			if (block == start)
			{
				/* Need to get more from the system.  Check to see if
				the new core will be contiguous with the final free
				block; if so we don't need to get as much.  */
				block = cb->_heapinfo[0].free.prev;
				lastblocks = cb->_heapinfo[block].free.size;
				if (cb->_heaplimit != 0 && block + lastblocks == cb->_heaplimit &&
				cb->__morecore(0) == ADDRESS (block + lastblocks,cb) &&
				(morecore ( (blocks - lastblocks) * BLOCKSIZE,cb)) != NULL)
				{
 					/* Which block we are extending (the `final free
 						block' referred to above) might have changed, if
 						it got combined with a freed info table.  */
 					block = cb->_heapinfo[0].free.prev;
  					cb->_heapinfo[block].free.size += (blocks - lastblocks);
					cb->_bytes_free += (blocks - lastblocks) * BLOCKSIZE;
					continue;
				}
				result = morecore (blocks * BLOCKSIZE,cb);
				if (result == NULL)
					return NULL;
				block = BLOCK (result,cb);
				cb->_heapinfo[block].busy.type = 0;
				cb->_heapinfo[block].busy.info.size = blocks;
				++cb->_chunks_used;
				cb->_bytes_used += blocks * BLOCKSIZE;
                  assert (!result || ( (cb==&_hcb0) ? __IN_HEAP0(result): 
						                (cb==&_hcb1) ? __IN_HEAP1(result):
						                (cb==&_hcb2) ? __IN_HEAP2(result):
						                (cb==&_hcb3) && __IN_HEAP3(result) ) );
				return result;
			}
		}

		/* At this point we have found a suitable free list entry.
		Figure out how to remove what we need from the list. */
		result = ADDRESS (block,cb);
		StructFree& sfb = cb->_heapinfo[block].free;
		if ( sfb.size > blocks )
		{
		/* The block we found has a bit left over,
			so relink the tail end back into the free list. */
			StructFree& sfbs = cb->_heapinfo[block + blocks].free;
			sfbs = sfb;
			sfbs.size -= blocks;
			cb->_heapinfo[sfb.prev].free.next
				= cb->_heapinfo[sfb.next].free.prev
				= cb->_heapindex = block + blocks;
		}
		else
		{
		/* The block exactly matches our requirements,
			so just remove it from the list. */
			cb->_heapinfo[sfb.next].free.prev = sfb.prev;
			cb->_heapinfo[sfb.prev].free.next = cb->_heapindex = sfb.next;
			--cb->_chunks_free;
		}
		cb->_heapinfo[block].busy.type = 0;
		cb->_heapinfo[block].busy.info.size = blocks;
		++cb->_chunks_used;
		cb->_bytes_used += blocks * BLOCKSIZE;
		cb->_bytes_free -= blocks * BLOCKSIZE;
	}
  assert (!result || ( (cb==&_hcb0) ? __IN_HEAP0(result): 
						(cb==&_hcb1) ? __IN_HEAP1(result):
						(cb==&_hcb2) ? __IN_HEAP2(result):
						(cb==&_hcb3) && __IN_HEAP3(result) ) );
  return result;
}


__ptr_t malloc (__malloc_size_t size)
{
        __ptr_t p;
        p=__malloc_internal(size,&_hcb0);
		if (!p){
            p=__malloc_internal(size,&_hcb1);
 		    if (!p){
				p=__malloc_internal(size,&_hcb2);
				if (!p){
					p=__malloc_internal(size,&_hcb3);
				}
		    }
		}
#ifdef _HOME_DEBUG
        printf("<m %p> ",p);
#endif
        assert(!p || __IN_HEAP0(p) || __IN_HEAP1(p)|| __IN_HEAP2(p)|| __IN_HEAP3(p));
        return p;
}

__ptr_t malloc0 (__malloc_size_t size )
{
    __ptr_t p;
    p = __malloc_internal(size,&_hcb0);
#ifdef _HOME_DEBUG
    printf("<m %p> ",p);
#endif
    assert(!p || __IN_HEAP0(p));
    return p;

}

__ptr_t malloc1 (__malloc_size_t size )
{
    __ptr_t p;
    p = __malloc_internal(size,&_hcb1);
#ifdef _HOME_DEBUG
    printf("<m %p> ",p);
#endif
    assert(!p || __IN_HEAP1(p));
    return p;
}

__ptr_t malloc2 (__malloc_size_t size )
{
    __ptr_t p;
    p = __malloc_internal(size,&_hcb2);
#ifdef _HOME_DEBUG
    printf("<m %p> ",p);
#endif
    assert(!p || __IN_HEAP2(p));
    return p;

}

__ptr_t malloc3 (__malloc_size_t size )
{
    __ptr_t p;
    p = __malloc_internal(size,&_hcb3);
#ifdef _HOME_DEBUG
    printf("<m %p> ",p);
#endif
    assert(!p || __IN_HEAP3(p));
    return p;

}


#ifndef _LIBC

/* On some ANSI C systems, some libc functions call _malloc, _free
   and _realloc.  Make them use the GNU functions.  */

__ptr_t _malloc (__malloc_size_t size)
{
  return malloc (size);
}

void _free (__ptr_t ptr)
{
  free (ptr);
}

__ptr_t _realloc (__ptr_t ptr,__malloc_size_t size)
{
  return realloc (ptr, size);
}

#endif
