//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           mul32hi.asm                                    //
//                                                                          //
//    ,          //
//                                                                 //
//   Mul32HighS   -   3232 ->64                           //
//   Mul32HighU   -                                //
//                                                                          //
// Copyright (c) 2001 RC Module Inc.     ..                   //
//                                                                          //
//  $Revision:: 1   $    $Date::  $                                         //
//                                                                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

global Mul32HighS :label;
global Mul32HighU :label;

begin ".text"

//=====  Mul32HighS ========
//   32- . --   --
//    .
//  :    gr6  gr7.
//
//  : gr6:gr7 - 
//	 ar5

<Mul32HighS>
    
    ar5 = gr0		with gr0 = gr6 *: gr7;
.repeat 12;
					with gr0 = gr6 * gr7;
.endrepeat;

.align;
    delayed return	with gr0 = gr6 * gr7;
					with gr0 = gr6 * gr7;
					with gr0 = gr6 * gr7;
    gr0 = ar5		with gr6 = gr0;

//=====  Mul32HighU ========
//  ,   Mul32Ex,    
// ----  32- . -- --
//    .

//   - gr6, gr7
//   - gr6, gr7.
// : ar5

<Mul32HighU>

		//	p = mullhs(x,y)
		//	t1 = (x A>>31 )&y
		//	t2 = (y A>>31 )&x
		//	mullhu(x,y) = p +t1 +t2;

    push ar1, gr1 with gr1 = gr7; 
    push ar2, gr2 with gr2 = gr6 *: gr7;
    push ar3, gr3 with gr2 = gr6 * gr7;
    with gr2 = gr6 * gr7;
.repeat 13;
		with gr2 = gr6 * gr7;
.endrepeat;
		//	x == gr6
		//	y == gr1
		//	mullhs == gr2
		//	t == gr3
		//	t1 = (x A>>31 )&y
	with gr3 = gr6 A>>31;
	with gr3 = gr3 and gr1;
    with gr2 += gr3;
		//	t2 = (y A>>31 )&x
	with gr3 = gr1 A>>31;

    pop ar3, gr3 with gr6 = gr3 and gr6;	//	gr6 <- t2
    pop ar2, gr2 with gr6 += gr2;
    pop ar1, gr1;

    return;

end ".text";

 
//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         mul32hi.asm                            //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

