//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           mul64.asm                                      //
//                                                                          //
//     64- .                                       //
//   Mul32   -  64-  .                              //
//                                                                          //
// Copyright (c) 2001 RC Module Inc.                                        //
//                                                                          //
//  $Revision:: 1    $    $Date:: 2/14/06 8:08p $                           //
//                                                                          //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// :  ..
// :      .
//         64-  .

//  ..       " "  

global Mul64 : label;
global Mul32Ex : label;

begin text

	//      3232
    //   64- .
    //   - gr0, gr7
    //   - gr0, gr7.
<Mul32Ex>

		//	p = mullhs(x,y)
		//	t1 = (x A>>31 )&y
		//	t2 = (y A>>31 )&x
		//	mullhu(x,y) = p +t1 +t2;

    push ar1, gr1 with gr1 = gr7; 
    push ar2, gr2 with gr2 = gr0 *: gr7;
    push ar3, gr3 with gr2 = gr0 * gr7;
    with gr2 = gr0 * gr7;
.repeat 13;
		with gr2 = gr0 * gr7;
.endrepeat;
		//	x == gr0
		//	y == gr1
		//	mullhs == gr2
		//	t == gr3
		//	t1 = (x A>>31 )&y
	with gr3 = gr0 A>>31;
	with gr3 = gr3 and gr1;
    with gr2 += gr3;
		//	t2 = (y A>>31 )&x
	with gr3 = gr1 A>>31;

    pop ar3, gr3 with gr0 = gr3 and gr0;	//	gr0 <- t2
    pop ar2, gr2 with gr0 += gr2;
    pop ar1, gr1;

    return;

//=====  Mul64 ========
//  64- .
//    .
//  :
// +0 = SP    
// -1 = PSW
// -2 = PC
// -3 =  1, 32  
// -4 =  1, 32  
// -5 =  2, 32  
// -6 =  2, 32  
//
//  :
// +0 = SP    
// -1 = PSW
// -2 = PC
// -3 = , 32  
// -4 = , 32  
// -5 =  2, 32  
// -6 =  2, 32  
// : ar5, gr7

<Mul64>
    ar5 = sp;
    push ar0,gr0;
    push ar1,gr1;
    push ar2,gr2;
    push ar3,gr3;
    
    	// (a + 2^32*b) * (c + 2^32*d) = lo(a*c) + 2^32*(a*d + b*c + hi(a*c))
        //     .
        
    ar2, gr2 = [ ar5 -= 6 ];    // ar2 = a, gr2 = b
    ar3, gr3 = [ ar5 += 2 ];    // ar3 = c, gr3 = d

        // a*c
    delayed call Mul32Ex;
    gr0 = ar2;
    gr7 = ar3;
    
    ar1 = gr7;	// lo(a*c)
    gr1 = gr0;  // hi(a*c)
        
        // a*d
    delayed call Mul32Ex;
    gr0 = ar2;
    gr7 = gr3;

   	    // gr1 = hi(a*c) + lo(a*d)
    with gr1 += gr7;
    
        // b*c
    delayed call Mul32Ex;
    gr0 = gr2;
    gr7 = ar3;
    
   	    // gr1 = hi(a*c) + lo(a*d) + lo(b*c)
    with gr1 += gr7;
    
    [ar5] = ar1,gr1;
    
    pop ar3,gr3;
    pop ar2,gr2;
    pop ar1,gr1;
    pop ar0,gr0;
    
    return;
     
     

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         mul64.asm                              //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

